/** \file src/xtal/xtal_map.h
* \brief src/xtal/xtal_map.h
*/

#ifndef XTAL_MAP_H_INCLUDE_GUARD
#define XTAL_MAP_H_INCLUDE_GUARD

#pragma once

namespace xtal{

/**
* \xbind lib::builtin
* \xinherit lib::builtin::Any lib::builtin::Iterable
* \brief Azz
*/
class Map : public Base{
public:

	/**
	* \xbind
	* \brief ̘AzzIuWFNg𐶐
	*/
	Map();

	~Map();
	
	/**
	* \brief keyɑΉvfԂ
	* \param key ̂߂̃L[ 
	*/
	const AnyPtr& at(const AnyPtr& key);
	
	/**
	* \brief keyɑΉvfݒ肷
	* \param key ̂߂̃L[ 
	* \param value keyɑΉl
	*/	
	void set_at(const AnyPtr& key, const AnyPtr& value){
		insert(key, value);
	}

	/**
	* \xbind
	* \brief keyɑΉvfԂ
	* \param key ̂߂̃L[ 
	*/
	const AnyPtr& op_at(const AnyPtr& key);
	
	/**
	* \xbind
	* \brief keyɑΉvfݒ肷
	* \param key ̂߂̃L[ 
	* \param value keyɑΉl
	*/	
	void op_set_at(const AnyPtr& key, const AnyPtr& value){
		insert(key, value);
	}

	/**
	* \xbind
	* \brief keyɑΉvfݒ肷
	* \param key ̂߂̃L[ 
	* \param value keyɑΉl
	*/	
	void insert(const AnyPtr& key, const AnyPtr& value){
		const AnyPtr& akey = calc_key(key);
		table_.insert(akey, value);
	}

	/**
	* \xbind
	* \brief keyɑΉl폜
	* \param key ̂߂̃L[ 
	*/
	void erase(const AnyPtr& key){
		const AnyPtr& akey = calc_key(key);
		table_.erase(akey);
	}

	/**
	* \xbind
	* \brief Azzɓo^ꂽvf̐Ԃ
	* \return Azzɓo^ꂽvf̐
	*/
	uint_t size(){
		return table_.size();
	}
	
	/**
	* \xbind
	* \brief Azzɓo^ꂽvf̐Ԃ
	* \return Azzɓo^ꂽvf̐
	*/
	uint_t length(){
		return table_.size();
	}

	/**
	* \xbind
	* \brief 󂩒ׂ
	* \retval true 
	* \retval false 
	*/
	bool empty(){
		return table_.empty();
	}

	/**
	* \xbind
	* \brief 󂩒ׂ
	* \retval true 
	* \retval false 
	*/
	bool is_empty(){
		return table_.empty();
	}

	/**
	* \xbind
	* \brief AAzzԂ
	*/
	MapPtr op_cat(const MapPtr& a);

	/**
	* \xbind
	* \brief gƘAAgԂ
	*/
	const MapPtr& op_cat_assign(const MapPtr& a);
		
	/**
	* \xbind
	* \brief (key, value)vfƂAIteratorԂ
	*/
	AnyPtr pairs();
	
	/**
	* \xbind
	* \brief keyvfƂAIteratorԂ
	*/
	AnyPtr keys();
	
	/**
	* \xbind
	* \brief valuevfƂAIteratorԂ
	*/
	AnyPtr values();

	/**
	* \xbind
	* \brief (key, value)vfƂAIteratorԂ
	* pairsƓ
	*/
	AnyPtr each(){
		return pairs();
	}
	
	/**
	* \xbind
	* \brief 󂢃Rs[Ԃ
	*/
	MapPtr clone();

	/**
	* \xbind
	* \brief vfSč폜
	*/
	void clear();

	/**
	* \xbind
	* \brief gԂ
	*/
	const MapPtr& op_to_map(){
		return to_smartptr(this);
	}

	/**
	* \xbind
	* \brief giteratorŎ擾łvfɒu
	*/
	void assign(const AnyPtr& iterator);

	/**
	* \xbind
	* \brief iteratorŎ擾łvfǉ
	*/
	void append(const AnyPtr& iterator);

	void push_all(const VMachinePtr& vm);

	/**
	* \xbind
	* \brief ftHglƂĐݒ肳ĂIuWFNgo
	* \return ftHgl
	*/
	const AnyPtr& default_value(){
		return default_value_;
	}

	/**
	* \xbind
	* \brief ftHglݒ肷
	* \param default_value ftHgl
	*/
	void set_default_value(const AnyPtr& default_value){
		default_value_ = default_value;
	}

	StringPtr to_s();

public:

	void block_first(const VMachinePtr& vm);

	struct Fun{
		static uint_t hash(const AnyPtr& key){
			return (rawvalue(key).u() ^ type(key) ^ (rawvalue(key).u()>>3));
		}

		static bool eq(const AnyPtr& a, const AnyPtr& b){
			return raweq(a, b);
		}
	};

	typedef OrderedHashtable<AnyPtr, AnyPtr, Fun> table_t;

	 AnyPtr calc_key(const AnyPtr& key);

public:

	typedef table_t::iterator iterator;

	iterator begin(){
		return table_.begin();
	}

	iterator end(){
		return table_.end();
	}

	iterator find_direct(const AnyPtr& key){
		return table_.find(key);
	}

	void insert_direct(const AnyPtr& key, const AnyPtr& value){
		table_.insert(key, value);
	}

	void on_visit_members(Visitor& m);
	
protected:

	table_t table_;
	AnyPtr default_value_;
};

class MapIter : public Base{
public:

	MapIter(const MapPtr& m, int_t type);
	
	void block_next(const VMachinePtr& vm);

public:

	bool block_next_direct(AnyPtr& rkey, AnyPtr& rval);

	void on_visit_members(Visitor& m);

private:
	MapPtr map_;
	Map::iterator node_;
	int_t type_;

};

class Set : public Map{
public:

	/**
	* \brief value^keyvfƂIteratorԂ
	*
	*/
	AnyPtr each();

	StringPtr to_s();
};


template<>
struct XNew<Map> : XXNew<Map>{
	XNew();
};


}//namespace


#endif // XTAL_MAP_H_INCLUDE_GUARD
